#
#  CNDocument.rb
#  CocoaNav
#
#  Created by Patrick Geiller on 18/05/08.
#  Copyright (c) 2008 __MyCompanyName__. All rights reserved.
#

require 'osx/cocoa'

#
# CNDocument store document type ('default' (loads all frameworks) or 'blank')
#
class CNDocument < OSX::NSDocument

  def windowNibName
    # Implement this to return a nib to load OR implement
    # -makeWindowControllers to manually create your controllers.
    return "CNDocument"
  end

  def dataRepresentationOfType(type)
    # Implement to provide a persistent data representation of your
    # document OR remove this and implement the file-wrapper or file
    # path based save methods.
    return nil
  end

  def loadDataRepresentation_ofType(data, type)
    # Implement to load a persistent data representation of your
    # document OR remove this and implement the file-wrapper or file
    # path based load methods.
    return true
  end
  
	def displayName
		'CocoaNav'
	end
  
  
	def awakeFromNib
		@userFrameworks = []
	end
  
	kvc_accessor :type
	kvc_accessor :userFrameworks


	#
	# Check user framework presence
	#
	def isUserFrameworkLoaded(path)
		@userFrameworks.index(path) != nil
	end

	#
	# Maybe load user framework
	#
	def maybeLoadUserFramework(path)
		if path.to_s.match(/xcodeproj/)
			s = path.split('/')
			s.pop
			path = s.join('/')
		end
		
		# Load framework
		loadUserFramework(path) if !isUserFrameworkLoaded(path)
		if !NSApp.delegate.isFrameworkLoaded(path)
			NSApp.delegate.loadFramework(path, 'user') 
			NSApp.delegate.computeHierarchy
		end
	end

	#
	# Load user framework
	#
	def loadUserFramework(path)
		@userFrameworks << path
	end


end
