#
#  CNWindowPreferences.rb
#  CocoaNav
#
#  Created by Patrick Geiller on 16/05/08.
#  Copyright (c) 2008 __MyCompanyName__. All rights reserved.
#

require 'osx/cocoa'


#
# Preferences dispatches color changes to ApplicationController
#
class CNWindowPreferences < NSWindow

	ib_outlet :frameworksColorsController
	ib_outlet :userDefaults

	#
	# Observe preferences window's color changes
	#
	def awakeFromNib
		@frameworksColorsController.addObserver_forKeyPath_options_context(self, 'selection.name', 0, nil)
		@frameworksColorsController.addObserver_forKeyPath_options_context(self, 'selection.enabled', 0, nil)
		@frameworksColorsController.addObserver_forKeyPath_options_context(self, 'selection.color', 0, nil)
		@frameworksColorsController.addObserver_forKeyPath_options_context(self, 'selection.textColor', 0, nil)

		@userDefaults.addObserver_forKeyPath_options_context(self, 'values.systemFrameworkColor', 0, nil)
		@userDefaults.addObserver_forKeyPath_options_context(self, 'values.systemFrameworkTextColor', 0, nil)

		@userDefaults.addObserver_forKeyPath_options_context(self, 'values.userFrameworkColor', 0, nil)
		@userDefaults.addObserver_forKeyPath_options_context(self, 'values.userFrameworkTextColor', 0, nil)
	end

	def observeValueForKeyPath_ofObject_change_context(keyPath, object, change, context)
		NSApp.delegate.colorChanged
	end

	#
	# dealloc
	#
	def dealloc
		@frameworksColorsController.removeObserver_forKeyPath(self, 'selection.name', 0, nil)
		@frameworksColorsController.removeObserver_forKeyPath(self, 'selection.enabled', 0, nil)
		@frameworksColorsController.removeObserver_forKeyPath(self, 'selection.color', 0, nil)
		@frameworksColorsController.removeObserver_forKeyPath(self, 'selection.textColor', 0, nil)

		@userDefaults.removeObserver_forKeyPath(self, 'values.systemFrameworkColor', 0, nil)
		@userDefaults.removeObserver_forKeyPath(self, 'values.systemFrameworkTextColor', 0, nil)

		@userDefaults.removeObserver_forKeyPath(self, 'values.userFrameworkColor', 0, nil)
		@userDefaults.removeObserver_forKeyPath(self, 'values.userFrameworkTextColor', 0, nil)
		
		super_dealloc
	end

end
